/* screen.h
**
** Copyright (c) 1987-90, Chris Laforet Software/Chris Laforet
** All Rights Reserved
**
** Started: 17 February 1990
**
** Revision Information: $Logfile:   F:/libs/scrnlib/vcs/screen.h_v  $
**                       $Date:   20 Feb 1990 05:03:10  $
**                       $Revision:   1.1  $
**
*/


#ifdef __cplusplus
extern "C"
	{
#endif

#ifndef LIBRARY
	#ifndef __TURBOC__
		#ifndef __ZTC__
			#ifndef PROTECTED
				#pragma comment(lib,"LSCREEN")
			#else
				#pragma comment(lib,"LSCREENP")
			#endif
		#endif
	#endif
#endif


#define BLACK			0
#define BLUE			1
#define GREEN			2
#define CYAN			3
#define RED				4
#define MAGENTA			5
#define BROWN			6
#define LT_GRAY			7
#define NORMAL			7
#define GRAY			8
#define LT_BLUE			9
#define LT_GREEN		10
#define LT_CYAN			11
#define LT_RED			12
#define LT_MAGENTA		13
#define YELLOW			14
#define WHITE			15
#define INTENSE			15
#define BLINK			0x80
#define ON_BLUE			0x10
#define ON_GREEN		0x20
#define ON_CYAN			0x30
#define ON_RED			0x40
#define ON_MAGENTA		0x50
#define ON_YELLOW		0x60
#define ON_WHITE		0x70
#define INVERSE			0x70

#define HIDDEN			0x0		/* Cursor definitions */
#define LINE			0x1
#define UPPER_HALF		0x2
#define LOWER_HALF		0x3
#define FULL			0x4

#define TEST_EGA		0
#define NO_TEST_EGA 	1


#ifdef PROTECTED
	#define CURPOS  (_getcurpos())
#else
	#define CURPOS  (cur_ega->cursor_posn[(cur_ega->active_page)])

	struct ega_vals
		{
		unsigned char crt_mode;
		unsigned int crt_cols;
		unsigned int crt_len;
		unsigned int crt_start;
		unsigned int cursor_posn[8];
		unsigned int cursor_mode;
		unsigned char active_page;
		unsigned int addr_6845;
		unsigned char crt_mode_set;
		unsigned char crt_palette;
		};
	extern int snow_flag;
	extern int ega_here;
	extern int __screen_length;
	extern unsigned long __cpu;
	extern struct ega_vals far *cur_ega;
#endif



extern int cga_here;
extern int ega_here;
extern int mono_here;
extern int ega_active;
extern int ega43flag;
extern int ega_mono_card;
extern int max_vrt_chrs;

extern int far scr_init(void);

extern void set_25(void);
extern void set_43(void);

extern void far set_new_cursor(int cursor,int difference);
extern void far set_cursor_type(int type);
extern int far _setcurmode(int mode);
extern void far _setcurpos(int cursor);

extern void far _cls(int attribute);

extern int far prntnomov(int cursor,int length,int attribute,char far *string);
extern int far prntnomovf(int cursor,int length,int attribute,char far *format,...);

extern int far prntmov(int cursor,int length,int attribute,char far *string);
extern int far prntmovf(int cursor,int length,int attribute,char far *format,...);

extern int far prntmem(int length,int attribute,void far *buffer,char far *string);
extern int far prntmemf(int length,int attribute,void far *buffer,char far *format,...);

extern int far prntcenter(int cursor,int width,int color,char *string);

extern int far _vcw(char character,int attribute,int cursor,int length);
extern int far _vsw(char far *string,int cursor,int length,int attribute);

extern int far _bcw(char character,int attribute,int length,void far *buffer);
extern int far _bsw(char *string,int length,int attribute,void far *buffer);

extern int far _vbw(void far *buffer,int cursor,int length);
extern int far _vbr(void far * buffer,int cursor,int length);

#ifdef PROTECTED
/* protected mode only */
extern int _getcurpos(void);
extern int get_cursor_type(void);
#endif

#ifdef __cplusplus
	}
#endif

